Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/SlaveStatusInfo.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/SlaveStatusInfo.cs	(revision 6723)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/SlaveStatusInfo.cs	(revision 6725)
@@ -26,10 +26,10 @@
   public class SlaveStatusInfo {
     private static object coreLock = new object();
-    private static int jobsFetched;  // number of fetched jobs
-    private static int jobsStarted;  // number of started jobs
-    private static int jobsFinished; // everything went fine
-    private static int jobsAborted;  // server sent abort
-    private static int jobsFailed;   // jobs that failed in the sandbox
-    private static int exceptionsOccured; // number jobs failed caused by the business logic, not a faulted job
+    private static int tasksFetched;  // number of fetched jobs
+    private static int tasksStarted;  // number of started jobs
+    private static int tasksFinished; // everything went fine
+    private static int tasksAborted;  // server sent abort
+    private static int tasksFailed;   // tasks that failed in the sandbox
+    private static int exceptionsOccured; // number jobs failed caused by the business logic, not a faulted task
     private static int usedCores;    // number of cores currently used
 
@@ -40,22 +40,22 @@
     }
 
-    public static int JobsStarted {
-      get { return jobsStarted; }
+    public static int TasksStarted {
+      get { return tasksStarted; }
     }
 
-    public static int JobsFinished {
-      get { return jobsFinished; }
+    public static int TasksFinished {
+      get { return tasksFinished; }
     }
 
-    public static int JobsAborted {
-      get { return jobsAborted; }
+    public static int TasksAborted {
+      get { return tasksAborted; }
     }
 
-    public static int JobsFetched {
-      get { return jobsFetched; }
+    public static int TasksFetched {
+      get { return tasksFetched; }
     }
 
-    public static int JobsFailed {
-      get { return jobsFailed; }
+    public static int TasksFailed {
+      get { return tasksFailed; }
     }
 
@@ -64,22 +64,22 @@
     }
 
-    public static void IncrementJobsStarted() {
-      Interlocked.Increment(ref jobsStarted);
+    public static void IncrementTasksStarted() {
+      Interlocked.Increment(ref tasksStarted);
     }
 
-    public static void IncrementJobsFinished() {
-      Interlocked.Increment(ref jobsFinished);
+    public static void IncrementTasksFinished() {
+      Interlocked.Increment(ref tasksFinished);
     }
 
-    public static void IncrementJobsFailed() {
-      Interlocked.Increment(ref jobsFailed);
+    public static void IncrementTasksFailed() {
+      Interlocked.Increment(ref tasksFailed);
     }
 
-    public static void IncrementJobsAborted() {
-      Interlocked.Increment(ref jobsAborted);
+    public static void IncrementTasksAborted() {
+      Interlocked.Increment(ref tasksAborted);
     }
 
-    public static void IncrementJobsFetched() {
-      Interlocked.Increment(ref jobsFetched);
+    public static void IncrementTasksFetched() {
+      Interlocked.Increment(ref tasksFetched);
     }
 
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/SlaveTask.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/SlaveTask.cs	(revision 6725)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/SlaveTask.cs	(revision 6725)
@@ -0,0 +1,262 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.IO;
+using System.Threading;
+using HeuristicLab.Clients.Hive.SlaveCore.Properties;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.PluginInfrastructure.Sandboxing;
+
+namespace HeuristicLab.Clients.Hive.SlaveCore {
+
+  /// <summary>
+  ///  Manages a single task and it's appdomain. 
+  /// </summary>
+  public class SlaveTask : MarshalByRefObject {
+    private Executor executor;
+    private AppDomain appDomain;
+    private Semaphore waitForStartBeforeKillSem;
+    private bool executorMonitoringRun;
+    private Thread executorMonitoringThread;
+    private PluginManager pluginManager;
+    private ILog log;
+    public Guid TaskId { get; private set; }
+    public bool IsPrepared { get; private set; }
+
+    private int coresNeeded;
+    public int CoresNeeded {
+      get { return coresNeeded; }
+      set { this.coresNeeded = value; }
+    }
+
+    public TimeSpan ExecutionTime {
+      get { return executor != null ? executor.ExecutionTime : TimeSpan.Zero; }
+    }
+
+    public SlaveTask(PluginManager pluginManager, int coresNeeded, ILog log) {
+      this.pluginManager = pluginManager;
+      this.coresNeeded = coresNeeded;
+      this.log = log;
+      waitForStartBeforeKillSem = new Semaphore(0, 1);
+      executorMonitoringRun = true;
+      IsPrepared = false;
+    }
+
+    public void StartJobAsync(Task task, TaskData taskData) {
+      try {
+        this.TaskId = task.Id;
+        Prepare(task);
+        StartTaskInAppDomain(taskData);
+      }
+      catch (Exception) {
+        // make sure to clean up if something went wrong
+        DisposeAppDomain();
+        throw;
+      }
+    }
+
+    public void PauseTask() {
+      if (!IsPrepared) throw new AppDomainNotCreatedException();
+      if (!executor.IsPausing && !executor.IsStopping) executor.Pause();
+    }
+
+    public void StopTask() {
+      if (!IsPrepared) throw new AppDomainNotCreatedException();
+      if (!executor.IsPausing && !executor.IsStopping) executor.Stop();
+    }
+
+    private void Prepare(Task task) {
+      string pluginDir = Path.Combine(pluginManager.PluginTempBaseDir, task.Id.ToString());
+      string configFileName;
+      pluginManager.PreparePlugins(task, out configFileName);
+      appDomain = CreateAppDomain(task, pluginDir, configFileName);
+      IsPrepared = true;
+    }
+
+    private AppDomain CreateAppDomain(Task task, String pluginDir, string configFileName) {
+      if (task.IsPrivileged) {
+        appDomain = SandboxManager.CreateAndInitPrivilegedSandbox(task.Id.ToString(), pluginDir, Path.Combine(pluginDir, configFileName));
+      } else {
+        appDomain = SandboxManager.CreateAndInitSandbox(task.Id.ToString(), pluginDir, Path.Combine(pluginDir, configFileName));
+      }
+      appDomain.UnhandledException += new UnhandledExceptionEventHandler(AppDomain_UnhandledException);
+
+      log.LogMessage("Creating AppDomain");
+      executor = (Executor)appDomain.CreateInstanceAndUnwrap(typeof(Executor).Assembly.GetName().Name, typeof(Executor).FullName);
+
+      executor.TaskId = task.Id;
+      executor.CoresNeeded = task.CoresNeeded;
+      executor.MemoryNeeded = task.MemoryNeeded;
+      return appDomain;
+    }
+
+    private void StartTaskInAppDomain(TaskData taskData) {
+      executor.Start(taskData.Data);
+      waitForStartBeforeKillSem.Release();
+      StartExecutorMonitoringThread();
+    }
+
+    public void DisposeAppDomain() {
+      log.LogMessage(string.Format("Shutting down Appdomain for Task {0}", TaskId));
+      StopExecutorMonitoringThread();
+
+      if (executor != null) {
+        executor.Dispose();
+      }
+
+      if (appDomain != null) {
+        appDomain.UnhandledException -= new UnhandledExceptionEventHandler(AppDomain_UnhandledException);
+        int repeat = Settings.Default.PluginDeletionRetries;
+        while (repeat > 0) {
+          try {
+            waitForStartBeforeKillSem.WaitOne();
+            AppDomain.Unload(appDomain);
+            waitForStartBeforeKillSem.Dispose();
+            repeat = 0;
+          }
+          catch (CannotUnloadAppDomainException) {
+            log.LogMessage("Could not unload AppDomain, will try again in 1 sec.");
+            Thread.Sleep(Settings.Default.PluginDeletionTimeout);
+            repeat--;
+            if (repeat == 0) {
+              throw; // rethrow and let app crash
+            }
+          }
+        }
+      }
+      pluginManager.DeletePluginsForJob(TaskId);
+      GC.Collect();
+    }
+
+    private void AppDomain_UnhandledException(object sender, UnhandledExceptionEventArgs e) {
+      DisposeAppDomain();
+      OnExceptionOccured(new Exception("Unhandled exception: " + e.ExceptionObject.ToString()));
+    }
+
+    public TaskData GetTaskData() {
+      return executor.GetTaskData();
+    }
+
+    #region ExecutorMonitorThread
+    private void StartExecutorMonitoringThread() {
+      executorMonitoringThread = new Thread(MonitorExecutor);
+      executorMonitoringThread.Start();
+    }
+
+    private void StopExecutorMonitoringThread() {
+      if (executorMonitoringThread != null) {
+        if (executorMonitoringRun) {
+          executorMonitoringRun = false;
+          executor.ExecutorCommandQueue.AddMessage(ExecutorMessageType.StopExecutorMonitoringThread);
+        }
+      }
+    }
+
+    /// <summary>
+    /// Because the executor is in an appdomain and is not able to call back 
+    /// (because of security -> lease time for marshall-by-ref object is 5 min),
+    /// we have to poll the executor for events we have to react to (e.g. task finished...)    
+    /// </summary>
+    private void MonitorExecutor() {
+      while (executorMonitoringRun) {
+        //this blocks through the appdomain border, that's why the lease gets renewed
+        ExecutorMessage message = executor.ExecutorCommandQueue.GetMessage();
+
+        switch (message.MessageType) {
+          case ExecutorMessageType.TaskStarted:
+            OnTaskStarted();
+            break;
+
+          case ExecutorMessageType.TaskPaused:
+            executorMonitoringRun = false;
+            OnTaskPaused();
+            DisposeAppDomain();
+            break;
+
+          case ExecutorMessageType.TaskStopped:
+            executorMonitoringRun = false;
+            OnTaskStopped();
+            DisposeAppDomain();
+            break;
+
+          case ExecutorMessageType.TaskFailed:
+            executorMonitoringRun = false;
+            OnTaskFailed(new TaskFailedException(executor.CurrentExceptionStr));
+            DisposeAppDomain();
+            break;
+
+          case ExecutorMessageType.StopExecutorMonitoringThread:
+            executorMonitoringRun = false;
+            break;
+
+          case ExecutorMessageType.ExceptionOccured:
+            executorMonitoringRun = false;
+            DisposeAppDomain();
+            if (executor.CurrentException != null) {
+              OnExceptionOccured(executor.CurrentException);
+            } else {
+              OnExceptionOccured(new Exception(string.Format("Unknow exception occured in Executor for task {0}", TaskId)));
+            }
+            break;
+        }
+      }
+    }
+    #endregion
+
+    public event EventHandler<EventArgs<Guid>> TaskStarted;
+    private void OnTaskStarted() {
+      var handler = TaskStarted;
+      if (handler != null) handler(this, new EventArgs<Guid>(this.TaskId));
+    }
+
+    public event EventHandler<EventArgs<Guid>> TaskStopped;
+    private void OnTaskStopped() {
+      var handler = TaskStopped;
+      if (handler != null) handler(this, new EventArgs<Guid>(this.TaskId));
+    }
+
+    public event EventHandler<EventArgs<Guid>> TaskPaused;
+    private void OnTaskPaused() {
+      var handler = TaskPaused;
+      if (handler != null) handler(this, new EventArgs<Guid>(this.TaskId));
+    }
+
+    public event EventHandler<EventArgs<Guid>> TaskAborted;
+    private void OnTaskAborted() {
+      var handler = TaskAborted;
+      if (handler != null) handler(this, new EventArgs<Guid>(this.TaskId));
+    }
+
+    public event EventHandler<EventArgs<Guid, Exception>> TaskFailed;
+    private void OnTaskFailed(Exception exception) {
+      var handler = TaskFailed;
+      if (handler != null) handler(this, new EventArgs<Guid, Exception>(this.TaskId, exception));
+    }
+
+    public event EventHandler<EventArgs<Guid, Exception>> ExceptionOccured;
+    private void OnExceptionOccured(Exception exception) {
+      var handler = ExceptionOccured;
+      if (handler != null) handler(this, new EventArgs<Guid, Exception>(this.TaskId, exception));
+    }
+  }
+}
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/StatusCommons.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/StatusCommons.cs	(revision 6723)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/StatusCommons.cs	(revision 6725)
@@ -53,5 +53,5 @@
     public int ExceptionsOccured { get; set; }
     [DataMember]
-    public List<JobStatus> Jobs { get; set; }
+    public List<TaskStatus> Jobs { get; set; }
     [DataMember]
     public bool Asleep { get; set; }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/TaskStatus.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/TaskStatus.cs	(revision 6725)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/TaskStatus.cs	(revision 6725)
@@ -0,0 +1,39 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2011 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Runtime.Serialization;
+
+namespace HeuristicLab.Clients.Hive.SlaveCore {
+  [DataContract]
+  public class TaskStatus {
+    /// <summary>
+    /// Id of the Task
+    /// </summary>
+    [DataMember]
+    public Guid TaskId { get; set; }
+    /// <summary>
+    /// Current progress
+    /// </summary>
+    [DataMember]
+    public TimeSpan ExecutionTime { get; set; }
+  }
+}
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/WcfService.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/WcfService.cs	(revision 6723)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Slave/3.3/WcfService.cs	(revision 6725)
@@ -70,5 +70,5 @@
 
     /// <summary>
-    /// Uploads the jobData and sets a new jobState (while correctly setting Transferring state)
+    /// Uploads the taskData and sets a new jobState (while correctly setting Transferring state)
     /// </summary>
     public void UpdateJobData(Task job, TaskData jobData, Guid slaveId, TaskState state, string exception = "") {
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Tests/ExperimentManagerTests.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Tests/ExperimentManagerTests.cs	(revision 6723)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Tests/ExperimentManagerTests.cs	(revision 6725)
@@ -43,7 +43,7 @@
     [TestMethod]
     public void TestExperimentUpload() {
-      var rhc = new RefreshableHiveExperiment();
+      var rhc = new RefreshableJob();
       var optimizer = CreateOptimizer();
-      rhc.HiveJobs.Add(new OptimizerHiveJob(optimizer));
+      rhc.HiveJobs.Add(new OptimizerHiveTask(optimizer));
       
       HiveClient.StartExperiment((Exception ex) => TestContext.WriteLine(ex.ToString()), rhc, new CancellationToken());
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.3/HiveJobs/HiveJobListView.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.3/HiveJobs/HiveJobListView.cs	(revision 6723)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.3/HiveJobs/HiveJobListView.cs	(revision 6725)
@@ -27,6 +27,6 @@
 namespace HeuristicLab.Clients.Hive.Views {
   [View("JobItemList View")]
-  [Content(typeof(IItemList<HiveJob>), false)]
-  public partial class HiveJobListView : ItemListView<HiveJob> {
+  [Content(typeof(IItemList<HiveTask>), false)]
+  public partial class HiveJobListView : ItemListView<HiveTask> {
 
     public HiveJobListView() {
@@ -35,5 +35,5 @@
     }
 
-    protected override HiveJob CreateItem() {
+    protected override HiveTask CreateItem() {
       return null;
     }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.3/HiveJobs/HiveJobView.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.3/HiveJobs/HiveJobView.cs	(revision 6723)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.3/HiveJobs/HiveJobView.cs	(revision 6725)
@@ -26,10 +26,10 @@
 
 namespace HeuristicLab.Clients.Hive.Views {
-  [View("HiveJob View")]
-  [Content(typeof(HiveJob), true)]
-  [Content(typeof(HiveJob<>), false)]
+  [View("HiveTask View")]
+  [Content(typeof(HiveTask), true)]
+  [Content(typeof(HiveTask<>), false)]
   public partial class HiveJobView : ItemView {
-    public new HiveJob Content {
-      get { return (HiveJob)base.Content; }
+    public new HiveTask Content {
+      get { return (HiveTask)base.Content; }
       set {
         if (base.Content != value) {
@@ -61,6 +61,6 @@
     protected override void OnContentChanged() {
       base.OnContentChanged();
-      if (Content != null && Content.Job != null) {
-        computeInParallelCheckBox.Checked = Content.ItemJob.ComputeInParallel;
+      if (Content != null && Content.Task != null) {
+        computeInParallelCheckBox.Checked = Content.ItemTask.ComputeInParallel;
       } else {
         computeInParallelCheckBox.Checked = false;
@@ -72,14 +72,14 @@
 
     protected virtual void RegisterJobEvents() {
-      if (Content != null && Content.Job != null) {
-        Content.ItemJob.ComputeInParallelChanged += new EventHandler(OptimizerJob_ComputeInParallelChanged);
-        Content.ItemJob.ItemChanged += new EventHandler(Job_ItemChanged);
+      if (Content != null && Content.Task != null) {
+        Content.ItemTask.ComputeInParallelChanged += new EventHandler(OptimizerJob_ComputeInParallelChanged);
+        Content.ItemTask.ItemChanged += new EventHandler(Job_ItemChanged);
       }
     }
 
     protected virtual void DeregisterJobEvents() {
-      if (Content != null && Content.Job != null) {
-        Content.ItemJob.ComputeInParallelChanged -= new EventHandler(OptimizerJob_ComputeInParallelChanged);
-        Content.ItemJob.ItemChanged -= new EventHandler(Job_ItemChanged);
+      if (Content != null && Content.Task != null) {
+        Content.ItemTask.ComputeInParallelChanged -= new EventHandler(OptimizerJob_ComputeInParallelChanged);
+        Content.ItemTask.ItemChanged -= new EventHandler(Job_ItemChanged);
       }
     }
@@ -90,10 +90,10 @@
         Invoke(new EventHandler(Content_JobChanged), sender, e);
       } else {
-        if (Content != null && Content.Job != null) {
-          this.jobIdTextBox.Text = Content.Job.Id.ToString();
-          this.dateCreatedTextBox.Text = Content.Job.DateCreated.HasValue ? Content.Job.DateCreated.ToString() : string.Empty;
-          this.priorityTextBox.Text = Content.Job.Priority.ToString();
-          this.coresNeededTextBox.Text = Content.Job.CoresNeeded.ToString();
-          this.memoryNeededTextBox.Text = Content.Job.MemoryNeeded.ToString();
+        if (Content != null && Content.Task != null) {
+          this.jobIdTextBox.Text = Content.Task.Id.ToString();
+          this.dateCreatedTextBox.Text = Content.Task.DateCreated.HasValue ? Content.Task.DateCreated.ToString() : string.Empty;
+          this.priorityTextBox.Text = Content.Task.Priority.ToString();
+          this.coresNeededTextBox.Text = Content.Task.CoresNeeded.ToString();
+          this.memoryNeededTextBox.Text = Content.Task.MemoryNeeded.ToString();
         } else {
           this.jobIdTextBox.Text = string.Empty;
@@ -112,6 +112,6 @@
 
     protected virtual void Job_ItemChanged(object sender, EventArgs e) {
-      if (Content != null && Content.Job != null && Content.ItemJob.Item != null) {
-        optimizerItemView.Content = Content.ItemJob.Item;
+      if (Content != null && Content.Task != null && Content.ItemTask.Item != null) {
+        optimizerItemView.Content = Content.ItemTask.Item;
       } else {
         optimizerItemView.Content = null;
@@ -123,11 +123,11 @@
         Invoke(new EventHandler(Content_TaskStateChanged), sender, e);
       } else {
-        if (Content != null && Content.Job != null) {
-          this.stateTextBox.Text = Content.Job.State.ToString();
-          this.commandTextBox.Text = Content.Job.Command.ToString();
-          this.executionTimeTextBox.Text = Content.Job.ExecutionTime.ToString();
-          this.dateFinishedTextBox.Text = Content.Job.DateFinished.ToString();
-          this.exceptionTextBox.Text = Content.Job.CurrentStateLog != null ? Content.Job.CurrentStateLog.Exception : string.Empty;
-          this.lastUpdatedTextBox.Text = Content.Job.LastJobDataUpdate.ToString();
+        if (Content != null && Content.Task != null) {
+          this.stateTextBox.Text = Content.Task.State.ToString();
+          this.commandTextBox.Text = Content.Task.Command.ToString();
+          this.executionTimeTextBox.Text = Content.Task.ExecutionTime.ToString();
+          this.dateFinishedTextBox.Text = Content.Task.DateFinished.ToString();
+          this.exceptionTextBox.Text = Content.Task.CurrentStateLog != null ? Content.Task.CurrentStateLog.Exception : string.Empty;
+          this.lastUpdatedTextBox.Text = Content.Task.LastJobDataUpdate.ToString();
         } else {
           this.stateTextBox.Text = string.Empty;
@@ -148,5 +148,5 @@
         Invoke(new EventHandler(OptimizerJob_ComputeInParallelChanged), sender, e);
       } else {
-        computeInParallelCheckBox.Checked = Content.ItemJob.ComputeInParallel;
+        computeInParallelCheckBox.Checked = Content.ItemTask.ComputeInParallel;
       }
     }
@@ -154,5 +154,5 @@
     protected virtual void Content_StateLogChanged(object sender, EventArgs e) {
       if (Content != null) {
-        if (Content.ItemJob.ComputeInParallel) {
+        if (Content.ItemTask.ComputeInParallel) {
           this.stateLogViewHost.Content = Content.ChildStateLogList;
         } else {
@@ -167,6 +167,6 @@
     #region Child Control Events
     protected virtual void computeInParallelCheckBox_CheckedChanged(object sender, EventArgs e) {
-      if (Content != null && Content.ItemJob != null) {
-        this.Content.ItemJob.ComputeInParallel = this.computeInParallelCheckBox.Checked;
+      if (Content != null && Content.ItemTask != null) {
+        this.Content.ItemTask.ComputeInParallel = this.computeInParallelCheckBox.Checked;
       }
     }
@@ -180,5 +180,5 @@
 
     protected virtual void modifyItemButton_Click(object sender, EventArgs e) {
-      MainFormManager.MainForm.ShowContent(Content.ItemJob.Item);
+      MainFormManager.MainForm.ShowContent(Content.ItemTask.Item);
     }
     #endregion
@@ -199,7 +199,7 @@
       this.coresNeededTextBox.ReadOnly = this.ReadOnly;
       this.memoryNeededTextBox.ReadOnly = this.ReadOnly;
-      this.computeInParallelCheckBox.Enabled = !this.ReadOnly && this.Content != null && this.Content.ItemJob != null && this.Content.ItemJob.IsParallelizable;
-
-      this.modifyItemButton.Enabled = (Content != null && Content.ItemJob.Item != null && (Content.Job.State == TaskState.Paused || Content.Job.State == TaskState.Offline || Content.Job.State == TaskState.Finished || Content.Job.State == TaskState.Failed || Content.Job.State == TaskState.Aborted));
+      this.computeInParallelCheckBox.Enabled = !this.ReadOnly && this.Content != null && this.Content.ItemTask != null && this.Content.ItemTask.IsParallelizable;
+
+      this.modifyItemButton.Enabled = (Content != null && Content.ItemTask.Item != null && (Content.Task.State == TaskState.Paused || Content.Task.State == TaskState.Offline || Content.Task.State == TaskState.Finished || Content.Task.State == TaskState.Failed || Content.Task.State == TaskState.Aborted));
 
       optimizerItemView.ReadOnly = true;
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.3/HiveJobs/OptimizerHiveJobView.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.3/HiveJobs/OptimizerHiveJobView.cs	(revision 6723)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.3/HiveJobs/OptimizerHiveJobView.cs	(revision 6725)
@@ -25,9 +25,9 @@
 
 namespace HeuristicLab.Clients.Hive.Views {
-  [View("OptimizerHiveJob View")]
-  [Content(typeof(OptimizerHiveJob), true)]
+  [View("OptimizerHiveTask View")]
+  [Content(typeof(OptimizerHiveTask), true)]
   public partial class OptimizerHiveJobView : HiveJobView {
-    public new OptimizerHiveJob Content {
-      get { return (OptimizerHiveJob)base.Content; }
+    public new OptimizerHiveTask Content {
+      get { return (OptimizerHiveTask)base.Content; }
       set {
         if (base.Content != value) {
@@ -42,6 +42,6 @@
 
     protected override void Job_ItemChanged(object sender, EventArgs e) {
-      if (Content != null && Content.Job != null && Content.ItemJob.Item != null) {
-        runCollectionViewHost.Content = Content.ItemJob.Item.Runs;
+      if (Content != null && Content.Task != null && Content.ItemTask.Item != null) {
+        runCollectionViewHost.Content = Content.ItemTask.Item.Runs;
       } else {
         runCollectionViewHost.Content = null;
@@ -82,7 +82,7 @@
       base.SetEnabledStateOfControls();
 
-      this.restartButton.Enabled = Content != null && Content.IsControllable && !Content.Job.Command.HasValue && (Content.Job.State == TaskState.Paused || Content.Job.State == TaskState.Failed || Content.Job.State == TaskState.Aborted);
-      this.pauseButton.Enabled = Content != null && Content.IsControllable && !Content.Job.Command.HasValue && Content.Job.State == TaskState.Calculating;
-      this.stopButton.Enabled = Content != null && Content.IsControllable && !Content.Job.Command.HasValue && (Content.Job.State == TaskState.Calculating || Content.Job.State == TaskState.Waiting || Content.Job.State == TaskState.Paused);
+      this.restartButton.Enabled = Content != null && Content.IsControllable && !Content.Task.Command.HasValue && (Content.Task.State == TaskState.Paused || Content.Task.State == TaskState.Failed || Content.Task.State == TaskState.Aborted);
+      this.pauseButton.Enabled = Content != null && Content.IsControllable && !Content.Task.Command.HasValue && Content.Task.State == TaskState.Calculating;
+      this.stopButton.Enabled = Content != null && Content.IsControllable && !Content.Task.Command.HasValue && (Content.Task.State == TaskState.Calculating || Content.Task.State == TaskState.Waiting || Content.Task.State == TaskState.Paused);
     }
   }
Index: branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.3/TreeView/DeleteJobTreeNodeAction.cs
===================================================================
--- branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.3/TreeView/DeleteJobTreeNodeAction.cs	(revision 6723)
+++ branches/HeuristicLab.Hive-3.4/sources/HeuristicLab.Clients.Hive.Views/3.3/TreeView/DeleteJobTreeNodeAction.cs	(revision 6725)
@@ -5,8 +5,8 @@
 using HeuristicLab.Optimization;
 namespace HeuristicLab.Clients.Hive.Views.ExperimentManager.TreeView {
-  public class DeleteJobTreeNodeAction : IItemTreeNodeAction<HiveJob> {
-    private ItemCollection<HiveJob> hiveJobs;
+  public class DeleteJobTreeNodeAction : IItemTreeNodeAction<HiveTask> {
+    private ItemCollection<HiveTask> hiveJobs;
     
-    public DeleteJobTreeNodeAction(ItemCollection<HiveJob> hiveJobs) {
+    public DeleteJobTreeNodeAction(ItemCollection<HiveTask> hiveJobs) {
       this.hiveJobs = hiveJobs;
     }
@@ -20,11 +20,11 @@
     }
 
-    public void Execute(HiveJob item, HiveJob parentItem) {
+    public void Execute(HiveTask item, HiveTask parentItem) {
       if (parentItem == null) {
         hiveJobs.Remove(item);
       } else {
-        var experiment = parentItem.ItemJob.Item as Experiment;
+        var experiment = parentItem.ItemTask.Item as Experiment;
         if (experiment != null) {
-          experiment.Optimizers.Remove(((OptimizerJob)item.ItemJob).Item);
+          experiment.Optimizers.Remove(((OptimizerTask)item.ItemTask).Item);
         }
       }
